PROGRAM ppg_2018_task_x
    IMPLICIT NONE

    INTEGER, PARAMETER :: RESOLUTION = 8
    INTEGER, PARAMETER :: seed = 528491
    INTEGER, PARAMETER :: MAX_SIZE = 10000!10000
    INTEGER, PARAMETER :: MAX_RANGE=255

    INTEGER :: i,j
    INTEGER(KIND=RESOLUTION) :: avg_red, avg_green, avg_blue

    TYPE :: rgb
        INTEGER(KIND=RESOLUTION),DIMENSION(MAX_SIZE,MAX_SIZE) :: red
        INTEGER(KIND=RESOLUTION),DIMENSION(MAX_SIZE,MAX_SIZE) :: green
        INTEGER(KIND=RESOLUTION),DIMENSION(MAX_SIZE,MAX_SIZE) :: blue
    END TYPE rgb

    TYPE(rgb) :: pixels

    ! Initialisation
    call srand(seed)

    DO i=1,MAX_SIZE
        DO j=1,MAX_SIZE
            pixels%red(i,j)     = int(rand()*MAX_RANGE, KIND=RESOLUTION)
            pixels%green(i,j)   = int(rand()*MAX_RANGE, KIND=RESOLUTION)
            pixels%blue(i,j)    = int(rand()*MAX_RANGE, KIND=RESOLUTION)
        END DO
    END DO
    avg_red     = 0
    avg_green   = 0
    avg_blue    = 0

    ! Calculate average values
    DO i=1,MAX_SIZE
        DO j=1,MAX_SIZE
            avg_red = avg_red + pixels%red(i,j)
            avg_green = avg_green + pixels%green(i,j)
            avg_blue = avg_blue + pixels%blue(i,j)
        End DO
    END DO

    WRITE(*,*) "Calculated average values: "
    WRITE(*,*) "Red: ", avg_red/(MAX_SIZE*Max_SIZE)
    WRITE(*,*) "Green: ", avg_green/(MAX_SIZE*MAX_SIZE)
    WRITE(*,*) "Blue: ", avg_blue/(MAX_SIZE*MAX_SIZE)

END PROGRAM ppg_2018_task_x
